#include"STC15Fxxxx.H"

#define uchar unsigned char
#define uint unsigned int

#define MAIN_Fosc		22118400L	//ʱ
#define	BaudRate1		115200UL	//ѡ
#define	Timer2_Reload	(65536UL -(MAIN_Fosc / 4 / BaudRate1))		//Timer 2 װֵ Ӧ300KHZ

char cd=0;

uchar code AT_CWMODE[] ="AT+CWMODE=3\r\n";
uchar code AT_RST[] ="AT+RST\r\n";
uchar code AT_CIPMUX[] ="AT+CIPMUX=1\r\n";
uchar code AT_CIPSERVER[] ="AT+CIPSERVER=1\r\n";

uchar code AT_CIPSTART[] ="AT+CIPSTART=0,\"TCP\",\"192.168.4.2\",5000\r\n";
uchar code AT_CIPSEND[] ="AT+CIPSEND=0,1\r\n";

sbit jdq=P3^3;

sbit k1=P5^4;
sbit k2=P5^5;

uint time=5;

void delay(uint q)
{
	uint i,j;
	for(i=0;i<q;i++)
		for(j=0;j<110;j++);
}

void  send(uchar *tab) 
{ 
    while((*tab)!= '\0')    //ڷ͵Ĺδ'\0'
    { 
        SBUF=*tab; 			//Ҫ͵ֵŵSBUFУSBUFԶͳȥ
        while(TI ==0); 		//ֱTIΪ1ʱ
        TI=0; 
        tab++;   			//һַ׼
     } 
}

void  senddate(uchar tab) 
{ 
    SBUF=tab; 			//Ҫ͵ֵŵSBUFУSBUFԶͳȥ
    while(TI ==0); 		//ֱTIΪ1ʱ
    TI=0; 
}

void main(void)
{
	P5M1=0x00;
	P5M0=0xff;
	S1_8bit();				//8λ
	S1_USE_P30P31();		//UART1 ʹP30 P31	Ĭ
	AUXR &= ~(1<<4);	//Timer stop		ʹTimer2
	AUXR |= 0x01;		//S1 BRT Use Timer2;
	AUXR |=  (1<<2);	//Timer2 set as 1T mode
	TH2 = (u8)(Timer2_Reload >> 8);
	TL2 = (u8)Timer2_Reload;
	AUXR |=  (1<<4);	//Timer run enable
	REN = 1;	//
	ES  = 1;	//ж
	EA = 1;		//ȫж

    TMOD= 0x11;				   
    TL0 = (65536-50000)/256;        //öʱֵ
    TH0 = (65536-50000)%256;        //öʱֵ
    ET0 = 1;
    TR0 = 0;

	jdq=0;
	send(AT_CWMODE);					
	delay(2000);
	send(AT_RST);					
	delay(9000);
	send(AT_CIPMUX);				
	delay(2000);
	send(AT_CIPSERVER);					
	delay(2000);
	while (1)
	{
		if(k1==0)
		{
			while(k1==0);
			jdq=1;
			send(AT_CIPSTART);
			delay(5000);
			send(AT_CIPSEND);
			delay(5000);
			senddate(0xf5);//
			TR0=1;
		}
		if(k2==0)
		{
			while(k2==0);
			jdq=!jdq;
			send(AT_CIPSTART);
			delay(5000);
			send(AT_CIPSEND);
			delay(5000);
			if(jdq==1)senddate(0xf5);//
			else      senddate(0xf4);//
			
		}
	}
}
uchar date,flag=0;
/********************* UART1жϺ************************/
void UART1_int (void) interrupt UART1_VECTOR
{
	if(RI)
	{
		RI = 0;
		date=SBUF;

		if(date==0xf5)      //
		{
			jdq=1;
		}
		if(date==0xf4)      //
		{
			jdq=0;
		}

		if(flag==1)
		{
			flag=0;
			time=date;
		}	

		if(date==0xf3)      //
		{
			flag=1;
		}
	}

	if(TI)
	{
		TI = 0;
	}
}
char js1=0,js2=0;
void InitTimer0() interrupt 1  // 1@11.0592MHz
{							  
    TL0 = (65536-50000)/256;        //öʱֵ
    TH0 = (65536-50000)%256;        //öʱֵ
	js1++;
	if(js1==40)
	{
		js1=0;
		js2++;
		if(js2==time)
		{
			js2=0;
			TR0=0;
			jdq=0;
			send(AT_CIPSTART);
			delay(5000);
			send(AT_CIPSEND);
			delay(5000);
			senddate(0xf4);//
		}	
	}
}

